 ###############################################
#                                               #
#                  KESKIDI v2                   #
#     Module v1.0.0				  by Artix 		#
#                                               #
#       IRC:  irc.epiknet.org    #eggdrop		#
#                                               #
#		Contact me on www.eggdrop.fr			#
#		or send a mail to loyauflorian@gmail.com#
#                                               #
 ###############################################


########################## LICENCE #################################
#           DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
#                    Version 2, December 2004

# Copyright (C) 2004 Sam Hocevar <sam@hocevar.net>
#
# Everyone is permitted to copy and distribute verbatim or modified
# copies of this license document, and changing it is allowed as long
# as the name is changed.

#           DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
#   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

#  0. You just DO WHAT THE FUCK YOU WANT TO.

#####################################################################
# This program is free software. It comes without any warranty, to
# the extent permitted by applicable law. You can redistribute it
# and/or modify it under the terms of the Do What The Fuck You Want
# To Public License, Version 2, as published by Sam Hocevar. See
# http://sam.zoy.org/wtfpl/COPYING for more details.
#####################################################################

######################################
#		MODULE LOAD				     #
######################################
# If you don't load the module, there's just no way the script will ever work
# Check the README file for more details on how to install it
loadmodule keskidi


if {[info procs ::keskidi::uninstall] ne ""} { ::keskidi::uninstall }
namespace eval ::keskidi {
	######################################
	#				CONFIGURATION        #
	######################################

	## IMPORTANT STUFF ##
	# The Module uses the eggdrop's logs, so you have to 
	# enable logging in your config file.
	# Also, the script autodetects most of the settings,
	# which also means that if you were to change the
	# logfile-suffix variable, old log files wouldn't be 
	# recognized anymore.
    #
	# Please note that due to the way eggdrop use logs,
	# commands that trigger a bind won't be loggued by
	# default (eg. the !keskidi command)
	# whereas stuff that don't will be loggued as standard
	# text (eg. an admin command used by a standard user)

    #   
    # IRC BINDINGS
    ##########################
    # Public IRC Command to trigger the script
    variable pubCmd_keskidi !keskidi
    # User flags needed
    variable pubFlags_keskidi -|-
	
	# User Flags to ENABLE or DISABLE the use of the script
    variable pubFlags_switch m|o
    # Command to turn the script off
    variable pubCmd_off !keskidi.off
    # Command to enable it
    variable pubCmd_on !keskidi.on
	# Note that the script is NOT enabled by default.
	
	# GENERAL STUFF
    ##########################
    # Can mIRC Color/Bold/Underline codes be used by Keskidi ?
    variable codes 1
    #
    # Should we strip the messages of mIRC Codes before displaying them ?
    variable stripCodes 0
	#
    # Should we log manually the usage of the !keskidi command,
	# causing it to appear on the log (and therefore can then 
	# appear on the script)
    variable logKeskidi 1
	#
	# On how many days ago max. can we search ?
	variable maxDays 7
    
	####################################################################
	#                                                                  #
	#   DO NOT MODIFY ANYTHING BELOW THIS BOX IF YOU DON'T KNOW TCL    #
	#                                     (c) MenzAgitat               #
	####################################################################

    variable scriptVersion "1.0"
	
	setudef flag keskidi
	
	proc uninstall {args} {
        foreach binding [binds ::keskidi::*] {
            catch { unbind [lindex $binding 0] [lindex $binding 1] [lindex $binding 2] [lindex $binding 4] }
		}
	namespace delete ::keskidi }
	
	proc ::keskidi::mainKeskidi {nick chan {days 0}} {
		if {$days eq "" || ![string is digit $days] || $days > $::keskidi::maxDays || $days == 0} { set days $::keskidi::maxDays }
		if {([string first * $nick] != -1) && ($nick ne "*")} { set nick [string map {* ""} $nick] }
		
		if {![llength [set baseFile [lindex [lsearch -inline -index 1 [lsearch -all -inline -index 0 [logfile] *p*] $chan] 2]]]} { return !NOFILE1 }
		
		set baseFile_clock [string map {% %%} $baseFile]

		set fileList {}
		if {![set ::keep-all-logs]} {
			if {[file exists $baseFile]} { set fileList $baseFile }
			if {($setDays > 1) && [file exists "[set baseFile].yesterday"]} { lappend fileList "[set baseFile].yesterday" }
		} else { 
			foreach currentFile [glob -nocomplain -types f $baseFile*] { 
				if {$currentFile eq "$baseFile" || $currentFile eq "[set baseFile].yesterday"} { continue }
				
				catch {
					if {[clock scan $currentFile -format [set baseFile_clock][set ::logfile-suffix]] >= [expr [clock seconds] - 3600*24*$days]} { 
						lappend fileList $currentFile 
					}
				}
				
			}
		}
		
		if {[llength $fileList] == 0} { return !NOFILE2 }
		
		set cmd [list keskidi_search $nick]
		foreach file $fileList { lappend cmd $file }
		set modoutput [eval $cmd]
		if {$modoutput eq ""} { return !NOLINE }

		if {[string first \[ $modoutput] == 0} { set modoutput [join [lrange [split $modoutput] 1 end]] }

		if {$::keskidi::stripCodes} { set modoutput [stripcodes cbu $modoutput] }

		return $modoutput
	}
	
	proc ::keskidi::pubKeskidi {nick uhost hand chan text} {

    if {![channel get $chan keskidi]} { return }

    if {[string trim $text] eq ""} { 
		puthelp "PRIVMSG $chan :Usage: [code bold]$::keskidi::pubCmd_keskidi[code bold] <nickname>"
		return 0
	}
	set result [split [::keskidi::mainKeskidi [set requestedNick [lindex [split $text] 0]] $chan]]
	
	if {$result eq "!NOLINE"} { puthelp "PRIVMSG $chan :I don't recall [code bold]$requestedNick[code bold] saying anything...." 
	} elseif {$result eq "!NOFILE1"} { puthelp "PRIVMSG $chan :Logs are not enabled on the chan [code underline]$chan[code underline], so you just cannot use the [code bold]$::keskidi::pubCmd_keskidi[code bold] command on it." 
	} elseif {$result eq "!NOFILE2"} { puthelp "PRIVMSG $chan :The logfiles weren't found for some reason. Maybe they're not written yet, try again later." 
	} else {
		set targetNick [string range [lindex $result 0] 1 end-1]
		set answer [join [lrange $result 1 end]]
		putserv "PRIVMSG $chan :$targetNick said : [::keskidi::code 14]$answer[::keskidi::code endcolor]" 
	}
	
	if {$::keskidi::logKeskidi} { ::keskidi::autoLog }
	return 0
	}
	
	proc ::keskidi::autoLog {} { putloglev p $::_pub4 "<$::_pub1> $::_pubm5" }

	proc ::keskidi::code {code} {
    if {$code == "bold"} {
        if { $::keskidi::codes } { return "\002" } { return "" }
    } elseif {$code == "underline"} {
        if { $::keskidi::codes } { return "\037" } { return "" }
    } elseif {$code == "endcolor"} {
        if { $::keskidi::codes } { return "\003" } { return "" }
    } else {
        if { $::keskidi::codes } { return "\003$code" } { return "" }
    }
}

	proc ::keskidi::pubOn {nick uhost hand chan text} {
    if {![channel get $chan keskidi]} { 
            channel set $chan +keskidi
            putquick "PRIVMSG $chan :Enabling [code bold]$::keskidi::pubCmd_keskidi[code bold] on this channel." 
        } else {
            putquick "PRIVMSG $chan :[code bold]$::keskidi::pubCmd_keskidi[code bold] is already active on this channel."
        }
    }

	proc ::keskidi::pubOff {nick uhost hand chan text} {
    if {[channel get $chan keskidi]} { 
            channel set $chan -keskidi
            putquick "PRIVMSG $chan :Disabling [code bold]$::keskidi::pubCmd_keskidi[code bold] on this channel." 
        } else { 
            putquick "PRIVMSG $chan :[code bold]$::keskidi::pubCmd_keskidi[code bold] is not enabled on this channel."
        }
    }
	
	bind pub $::keskidi::pubFlags_keskidi $::keskidi::pubCmd_keskidi ::keskidi::pubKeskidi
	bind pub $::keskidi::pubFlags_switch $::keskidi::pubCmd_on ::keskidi::pubOn
	bind pub $::keskidi::pubFlags_switch $::keskidi::pubCmd_off ::keskidi::pubOff
	
	# Ding!
	putlog "'Keskidi' Script v$keskidi::scriptVersion by Artix (loyauflorian@gmail.com) was loaded successfully!"
}