 ###############################################
#                                               #
#                  KESKIDI v2                   #
#     Module v1.0.0				  by Artix 		#
#                                               #
#       IRC:  irc.epiknet.org         			#
#                                               #
#		Pour plus d'informations, contactez 	#
#		moi sur #eggdrop ou sur www.eggdrop.fr	#
#                                               #
 ###############################################


########################## LICENCE #################################
#           DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
#                    Version 2, December 2004

# Copyright (C) 2004 Sam Hocevar <sam@hocevar.net>
#
# Everyone is permitted to copy and distribute verbatim or modified
# copies of this license document, and changing it is allowed as long
# as the name is changed.

#           DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
#   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

#  0. You just DO WHAT THE FUCK YOU WANT TO.

#####################################################################
# This program is free software. It comes without any warranty, to
# the extent permitted by applicable law. You can redistribute it
# and/or modify it under the terms of the Do What The Fuck You Want
# To Public License, Version 2, as published by Sam Hocevar. See
# http://sam.zoy.org/wtfpl/COPYING for more details.
#####################################################################

######################################
#		CHARGEMENT DU MODULE	     #
######################################
# Le module est ncessaire a l'utilisation du script. 
# Par ce que, le script utilise le module.
# Bref, vous ne pouvez pas vous en passer, alors pas de questions, et on le charge, vu ?
loadmodule keskidi
# A noter que le paramtre de cette commande est un chemin relatif par rapport
# au repertoire de modules parametr dans le fichier de configuration de l'eggdrop 
# (c'est  dire par dfaut, modules/)
# Si vous changez le nom du fichier .dll ou .so, vous devrez changer son nom ici aussi.

if {[info procs ::keskidi::uninstall] ne ""} { ::keskidi::uninstall }
namespace eval ::keskidi {
	######################################
	#				CONFIGURATION        #
	######################################

    ## NOTE IMPORTANTE CONCERNANT LA CONFIGURATION ##
    # Afin de faciliter l'utilisation du script, 
    # tout est automatis pour utiliser un maximum
    # les paramtres de l'eggdrop.
    #
    # Cela implique cependant que l'eggdrop doit 
    # etre en train de logguer un canal pour que le
    # script puisse rechercher dans ses logs.
    #
    # Cela implique aussi que changer la variable
    # logfile-suffix va rendre incompatible vos anciens
    # logs : le script se base sur les variables actuelles,
    # n'ayant aucune informations concernant les logs.
    #
    # De plus, a moins que les procdures des scripts
    # soient rgles pour, l'eggdrop ne loggue pas les
    # commandes en bind public (pub).
    # Les commandes n'apparaiterons pas dans le keskidi
    # si un script est dclench.
    # Ceci veut dire que si un utilisateur utilise
    # une commande sans en avoir l'autorisation, 
    # elle sera automatiquement loggue par eggdrop.


    #### ----------------------------------- ####
    #### DEBUT DE LA PARTIE DE CONFIGURATION ####
    #### ----------------------------------- ####
    #   
    # PARAMETRE DES BINDS 
    ##########################
    # Commande de recherche de paroles en public
    variable pubCmd_keskidi !keskidi
    # Flags requis pour l'utilisation des commandes
    variable pubFlags_keskidi -|-
    #
    # Note: Keskidi est dsactiv sur tous les canaux par dfaut
    # Flags pour utiliser les commandes d'activation et dsactivation   
    # temporaires du keskidi
    variable pubFlags_switch m|o
    # Commande de dsactivation 
    variable pubCmd_off !keskidi.off
    # Commande de ractivation  
    variable pubCmd_on !keskidi.on
	
	# PARAMETRES DE KESKIDI
    ##########################
    # Utiliser des codes mIRC dans les messages (couleur, gras..) ?
    variable codes 1
    #
    # Lorsqu'un message trouv par le keskidi contiens des
    # codes mIRC, faut-il les retirer ?
    variable stripCodes 0
	#
    # Est ce qu'il faut logger l'utilisation de keskidi ?
    # L'avantage (ou pas), tant que les commandes du
    # keskidi peuvent apparaitre dans le keskidi !
    variable logKeskidi 1
	#
	# Nombre de jours max de recherche
	variable maxDays 7
    
	####################################################################
	#                                                                  #
	# NE MODIFIEZ RIEN APRES CE CADRE SI VOUS NE CONNAISSEZ PAS LE TCL #
	#                                                                  #
	#   DO NOT MODIFY ANYTHING BELOW THIS BOX IF YOU DON'T KNOW TCL    #
	#                                                                  #
	####################################################################

	# Version du script
    variable scriptVersion "1.0"
	
	setudef flag keskidi
	
	proc uninstall {args} {
        foreach binding [binds ::keskidi::*] {
            catch { unbind [lindex $binding 0] [lindex $binding 1] [lindex $binding 2] [lindex $binding 4] }
		}
	namespace delete ::keskidi }
	
	proc ::keskidi::mainKeskidi {nick chan {days 0}} {
		if {$days eq "" || ![string is digit $days] || $days > $::keskidi::maxDays || $days == 0} { set days $::keskidi::maxDays }
		if {([string first * $nick] != -1) && ($nick ne "*")} { set nick [string map {* ""} $nick] }
		
		# On cherche maintenant dans la liste des fichiers de logs de l'eggdrop
		#  - D'abord ceux qui loggent les messages publiques
		#  - Puis ceux qui correspondent en plus aux chan demand.
		# Le lindex 2 permet de rcuperer le nom du fichier de log.
		if {![llength [set baseFile [lindex [lsearch -inline -index 1 [lsearch -all -inline -index 0 [logfile] *p*] $chan] 2]]]} { return !NOFILE1 }
		
		# En doublant les %, on vite de choquer clock
		set baseFile_clock [string map {% %%} $baseFile]

		# Puisque je ne sais pas comment eggdrop gre ses fichiers logs, en
		# mettant suffixes et .yesterday, on vrifie simplement si un fichier 
		# existe avec le suffixe pour hier ou aujourd'hui
		set fileList {}
		if {![set ::keep-all-logs]} {
			# Si ce n'est pas le cas, on peut conclure illico que le fichier ne doit pas avoir de suffixe
			if {[file exists $baseFile]} { set fileList $baseFile }
			# On recherche aussi pour le fichier du jour prcdent
			if {($setDays > 1) && [file exists "[set baseFile].yesterday"]} { lappend fileList "[set baseFile].yesterday" }
		} else { 
			# Sinon, pour chaque fichier qui correspondait $baseFile*
			foreach currentFile [glob -nocomplain -types f $baseFile*] { 
				# On ignore le fichier de base et un ventuel .yesterday
				if {$currentFile eq "$baseFile" || $currentFile eq "[set baseFile].yesterday"} { continue }
				
				catch {
					if {[clock scan $currentFile -format [set baseFile_clock][set ::logfile-suffix]] >= [expr [clock seconds] - 3600*24*$days]} { 
						lappend fileList $currentFile 
					}
				}
				
			}
		}
		
		## Jusqu'a prsent, tout tait copi-coll du script original. Ou, je suis faignant, je sais ><
		## Sauf que c'est maintenant qu'il va falloir faire quelques changements: au lieu de lire le fichier
		## on appelle simplement le module pour qu'il le fasse a notre place. C'est tellement facile qu'en fait,
		## copier coller le reste tait peut tre mme plus fatiguant.
		
		if {[llength $fileList] == 0} { return !NOFILE2 }
		
		# Note: on doit utiliser un work-around bizarroide pour executer la commande, le nombre d'arguments tant
		# variable. Il est surement possible de passer une liste  C, mais je suis un dbutant, donc je sais pas faire :
		
		set cmd [list keskidi_search $nick]
		foreach file $fileList { lappend cmd $file }
		set modoutput [eval $cmd]
		if {$modoutput eq ""} { return !NOLINE }
		
		# On vire un eventuel timestamp
		if {[string first \[ $modoutput] == 0} { set modoutput [join [lrange [split $modoutput] 1 end]] }
		# Et les codes couleurs
		if {$::keskidi::stripCodes} { set modoutput [stripcodes cbu $modoutput] }

		return $modoutput
	}
	
	proc ::keskidi::pubKeskidi {nick uhost hand chan text} {
    # Si le canal n'est pas dans la liste, on vire tout de suite
    if {![channel get $chan keskidi]} { return }
    # Si on ne fournis aucun argument, on rappelle simplement la syntaxe
    if {[string trim $text] eq ""} { 
		puthelp "PRIVMSG $chan :La syntaxe est : [code bold]$::keskidi::pubCmd_keskidi[code bold] <pseudo>"
		return 0
	}
	set result [split [::keskidi::mainKeskidi [set requestedNick [lindex [split $text] 0]] $chan]]
	
	if {$result eq "!NOLINE"} { puthelp "PRIVMSG $chan :Je ne me souviens pas avoir entendu [code bold]$requestedNick[code bold] dire quelque chose ces derniers temps..." 
	} elseif {$result eq "!NOFILE1"} { puthelp "PRIVMSG $chan :Les logs ne sont pas activs sur le canal [code underline]$chan[code underline], il est donc impossible d'utiliser la commande [code bold]$::keskidi::pubCmd_keskidi[code bold] dessus." 
	} elseif {$result eq "!NOFILE2"} { puthelp "PRIVMSG $chan :Aprs recherche, aucun fichier de log n'a t trouv. Les logs n'ont peut-tre pas encore t cris, ressayez plus tard." 
	} else {
		set targetNick [string range [lindex $result 0] 1 end-1]
		set answer [join [lrange $result 1 end]]
		putserv "PRIVMSG $chan :$targetNick a dit : [::keskidi::code 14]$answer[::keskidi::code endcolor]" 
	}
	
	if {$::keskidi::logKeskidi} { ::keskidi::autoLog }
	return 0
	}
	
	proc ::keskidi::autoLog {} { putloglev p $::_pub4 "<$::_pub1> $::_pubm5" }

	# Proc tire du MDS de MenzAgitat
	proc ::keskidi::code {code} {
    if {$code == "bold"} {
        if { $::keskidi::codes } { return "\002" } { return "" }
    } elseif {$code == "underline"} {
        if { $::keskidi::codes } { return "\037" } { return "" }
    } elseif {$code == "endcolor"} {
        if { $::keskidi::codes } { return "\003" } { return "" }
    } else {
        if { $::keskidi::codes } { return "\003$code" } { return "" }
    }
}

	# Procdures d'activation, et de dsactivation
	proc ::keskidi::pubOn {nick uhost hand chan text} {
    if {![channel get $chan keskidi]} { 
            channel set $chan +keskidi
            putquick "PRIVMSG $chan :Activation de [code bold]$::keskidi::pubCmd_keskidi[code bold] sur ce canal." 
        } else {
            putquick "PRIVMSG $chan :[code bold]$::keskidi::pubCmd_keskidi[code bold] est dj activ sur le canal."
        }
    }

	proc ::keskidi::pubOff {nick uhost hand chan text} {
    if {[channel get $chan keskidi]} { 
            channel set $chan -keskidi
            putquick "PRIVMSG $chan :Dsactivation de [code bold]$::keskidi::pubCmd_keskidi[code bold] sur ce canal." 
        } else { 
            putquick "PRIVMSG $chan :[code bold]$::keskidi::pubCmd_keskidi[code bold] n'est pas activ sur le canal."
        }
    }
	
	bind pub $::keskidi::pubFlags_keskidi $::keskidi::pubCmd_keskidi ::keskidi::pubKeskidi
	bind pub $::keskidi::pubFlags_switch $::keskidi::pubCmd_on ::keskidi::pubOn
	bind pub $::keskidi::pubFlags_switch $::keskidi::pubCmd_off ::keskidi::pubOff
	
	# Ding!
	putlog "Keskidi script v$keskidi::scriptVersion par Artix a t charg !"
}